## fast-float 3.9.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

project(fast_float VERSION 3.9.0 LANGUAGES CXX)
option(FASTFLOAT_TEST "Enable tests" OFF)
if(FASTFLOAT_TEST)
  enable_testing()
  add_subdirectory(tests)
else(FASTFLOAT_TEST)
  message(STATUS "Tests are disabled. Set FASTFLOAT_TEST to ON to run tests.")
endif(FASTFLOAT_TEST)

option(FASTFLOAT_SANITIZE "Sanitize addresses" OFF)

if (NOT CMAKE_BUILD_TYPE)
  if(FASTFLOAT_SANITIZE)
    set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
  else()
    message(STATUS "No build type selected, default to Release")
    set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  endif()
endif()

option(FASTFLOAT_INSTALL "Enable install" ON)

if(FASTFLOAT_INSTALL)
  include(GNUInstallDirs)
endif()

add_library(fast_float INTERFACE)
add_library(FastFloat::fast_float ALIAS fast_float)
target_include_directories(
  fast_float
  INTERFACE
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)
target_compile_features(fast_float INTERFACE cxx_std_11)
if(FASTFLOAT_SANITIZE)
  target_compile_options(fast_float INTERFACE -fsanitize=address -fno-omit-frame-pointer -fsanitize=undefined -fno-sanitize-recover=all)
  target_link_libraries(fast_float INTERFACE -fsanitize=address -fno-omit-frame-pointer -fsanitize=undefined -fno-sanitize-recover=all)
  if (CMAKE_COMPILER_IS_GNUCC)
    target_link_libraries(fast_float INTERFACE -fuse-ld=gold)
  endif()
endif()
if(MSVC_VERSION GREATER 1910)
  target_compile_options(fast_float INTERFACE /permissive-)
endif()


if(FASTFLOAT_INSTALL)
  include(CMakePackageConfigHelpers)

  set(FASTFLOAT_VERSION_CONFIG "${CMAKE_CURRENT_BINARY_DIR}/module/FastFloatConfigVersion.cmake")
  set(FASTFLOAT_PROJECT_CONFIG "${CMAKE_CURRENT_BINARY_DIR}/module/FastFloatConfig.cmake")
  set(FASTFLOAT_CONFIG_INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/cmake/FastFloat")

  if(${CMAKE_VERSION} VERSION_LESS "3.14")
    write_basic_package_version_file("${FASTFLOAT_VERSION_CONFIG}" VERSION ${PROJECT_VERSION} COMPATIBILITY SameMajorVersion)
  else()
    write_basic_package_version_file("${FASTFLOAT_VERSION_CONFIG}" VERSION ${PROJECT_VERSION} COMPATIBILITY SameMajorVersion ARCH_INDEPENDENT)
  endif()
  configure_package_config_file("cmake/config.cmake.in"
                                "${FASTFLOAT_PROJECT_CONFIG}"
                                INSTALL_DESTINATION "${FASTFLOAT_CONFIG_INSTALL_DIR}")

  install(DIRECTORY "${PROJECT_SOURCE_DIR}/include/fast_float" DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
  install(FILES "${FASTFLOAT_PROJECT_CONFIG}" "${FASTFLOAT_VERSION_CONFIG}" DESTINATION "${FASTFLOAT_CONFIG_INSTALL_DIR}")
  install(EXPORT ${PROJECT_NAME}-targets NAMESPACE FastFloat:: DESTINATION "${FASTFLOAT_CONFIG_INSTALL_DIR}")

  install(TARGETS fast_float
          EXPORT ${PROJECT_NAME}-targets
          RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
          LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )
endif()

=== tests/CMakeLists.txt ===
# FetchContent requires cmake >=3.11
# see https://cmake.org/cmake/help/v3.11/module/FetchContent.html
cmake_minimum_required(VERSION 3.11 FATAL_ERROR)

include(FetchContent)

option(SYSTEM_DOCTEST "Use system copy of doctest" OFF)

if (NOT SYSTEM_DOCTEST)
  FetchContent_Declare(doctest
    GIT_REPOSITORY https://github.com/onqtam/doctest.git
    GIT_TAG v2.4.9)
endif()
FetchContent_Declare(supplemental_test_files
  GIT_REPOSITORY https://github.com/fastfloat/supplemental_test_files.git
  GIT_TAG origin/main)



# FetchContent_MakeAvailable() was only introduced in 3.14
# https://cmake.org/cmake/help/v3.14/release/3.14.html#modules
# FetchContent_MakeAvailable(doctest)
if (NOT SYSTEM_DOCTEST)
  FetchContent_GetProperties(doctest)
  if(NOT doctest_POPULATED)
    FetchContent_Populate(doctest)
    add_subdirectory(${doctest_SOURCE_DIR} ${doctest_BINARY_DIR})
  endif()
endif()
FetchContent_GetProperties(supplemental_test_files)
if(NOT supplemental_test_files_POPULATED)
  message(STATUS "Tests enabled. Retrieving test files.")
  FetchContent_Populate(supplemental_test_files)
  message(STATUS "Test files retrieved.")
  add_subdirectory(${supplemental_test_files_SOURCE_DIR} ${supplemental_test_files_BINARY_DIR})
endif()
add_library(supplemental-data INTERFACE)
target_compile_definitions(supplemental-data INTERFACE SUPPLEMENTAL_TEST_DATA_DIR="${supplemental_test_files_BINARY_DIR}/data")
function(fast_float_add_cpp_test TEST_NAME)
    add_executable(${TEST_NAME} ${TEST_NAME}.cpp)
    if(CMAKE_CROSSCOMPILING)
        set(ccemulator ${CMAKE_CROSSCOMPILING_EMULATOR})
    endif()
    add_test(NAME ${TEST_NAME}
        COMMAND ${ccemulator} $<TARGET_FILE:${TEST_NAME}>)
    if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
      target_compile_options(${TEST_NAME} PUBLIC /EHsc)
    endif()
    if(NOT WIN32)
      target_compile_options(${TEST_NAME} PUBLIC -Werror -Wall -Wextra -Weffc++)
      target_compile_options(${TEST_NAME} PUBLIC -Wsign-compare -Wshadow -Wwrite-strings -Wpointer-arith -Winit-self -Wconversion -Wsign-conversion)
    endif()
    target_link_libraries(${TEST_NAME} PUBLIC fast_float supplemental-data)
    if (NOT SYSTEM_DOCTEST)
      target_link_libraries(${TEST_NAME} PUBLIC doctest)
    endif()
endfunction(fast_float_add_cpp_test)

fast_float_add_cpp_test(rcppfastfloat_test)
fast_float_add_cpp_test(example_test)
fast_float_add_cpp_test(example_comma_test)
fast_float_add_cpp_test(basictest)
target_compile_features(basictest PRIVATE cxx_std_17)

fast_float_add_cpp_test(long_test)
fast_float_add_cpp_test(powersoffive_hardround)
fast_float_add_cpp_test(string_test)



option(FASTFLOAT_EXHAUSTIVE "Exhaustive tests" OFF)

if (FASTFLOAT_EXHAUSTIVE)
  fast_float_add_cpp_test(short_random_string)
  fast_float_add_cpp_test(exhaustive32_midpoint)
  fast_float_add_cpp_test(random_string)
  fast_float_add_cpp_test(exhaustive32)
  fast_float_add_cpp_test(exhaustive32_64)
  fast_float_add_cpp_test(long_exhaustive32)
  fast_float_add_cpp_test(long_exhaustive32_64)
  fast_float_add_cpp_test(long_random64)
  fast_float_add_cpp_test(random64)
endif(FASTFLOAT_EXHAUSTIVE)

add_subdirectory(build_tests)

=== tests/installation_tests/find/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

project(test_install VERSION 0.1.0 LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
if(MSVC_VERSION GREATER 1910)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -permissive-")
endif()
find_package(FastFloat REQUIRED)



file(WRITE main.cpp "
#include \"fast_float/fast_float.h\"
#include <iostream>
 
int main() {
    const std::string input =  \"3.1416 xyz \";
    double result;
    auto answer = fast_float::from_chars(input.data(), input.data()+input.size(), result);
    if(answer.ec != std::errc()) { std::cerr << \"parsing failure\\n\"; return EXIT_FAILURE; }
    std::cout << \"parsed the number \" << result << std::endl;
    return EXIT_SUCCESS;
}")



add_executable(repro main.cpp)
target_link_libraries(repro PUBLIC FastFloat::fast_float)

=== tests/installation_tests/issue72_installation/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

project(test_simdjson_install VERSION 0.1.0 LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
if(MSVC_VERSION GREATER 1910)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -permissive-")
endif()

find_package(FastFloat REQUIRED)



file(WRITE test.h "
#pragma once
#include \"fast_float/fast_float.h\"")

file(WRITE main.cpp "
#include \"test.h\"
int main() { return 0; }")

file(WRITE foo.cpp "
#include \"test.h\"
void foo() { }")
add_executable(issue72 main.cpp main.cpp)
target_link_libraries(issue72 PUBLIC FastFloat::fast_float)

=== debian/changelog ===
fast-float (3.9.0-1) unstable; urgency=medium

  * New upstream release 3.9.0.
  * Make fast_float_all.h available under /usr/include/fast_float/

 -- Fukui Daichi <a.dog.will.talk@akane.waseda.jp>  Sun, 05 Feb 2023 06:47:03 +0000

fast-float (3.5.1-1) unstable; urgency=low

  * Initial release. Closes: #1019961

 -- Fukui Daichi <a.dog.will.talk@akane.waseda.jp>  Thu, 15 Sep 2022 14:47:28 +0000

=== debian/control ===
Source: fast-float
Section: libdevel
Priority: optional
Maintainer: Fukui Daichi <a.dog.will.talk@akane.waseda.jp>
Build-Depends: cmake, debhelper-compat (= 13), python3
Standards-Version: 4.6.2
Homepage: https://github.com/fastfloat/fast_float
Rules-Requires-Root: no

Package: libfast-float-dev
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Implementation of the C++ from_chars functions for float and double types
 The fast_float library provides fast header-only
 implementations for the C++ from_chars functions
 for float and double types. These functions convert
 ASCII strings representing decimal valuesinto
 binary types. This library provides exact rounding
 (including round to even). These fast_float
 functions run many times faster than comparable
 number-parsing functions from existing C++ standard
 libraries.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%fast-float-$1.tar.gz%,repacksuffix=+ds,dversionmangle=s/\+ds\d*$//" \
https://github.com/fastfloat/fast_float/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## fast-float 8.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,10 @@
 cmake_minimum_required(VERSION 3.9)
 
-project(fast_float VERSION 3.9.0 LANGUAGES CXX)
+project(fast_float VERSION 8.0.0 LANGUAGES CXX)
+set(FASTFLOAT_CXX_STANDARD 11 CACHE STRING "the C++ standard to use for fastfloat")
+set(CMAKE_CXX_STANDARD ${FASTFLOAT_CXX_STANDARD})
 option(FASTFLOAT_TEST "Enable tests" OFF)
+
 if(FASTFLOAT_TEST)
   enable_testing()
   add_subdirectory(tests)
@@ -27,6 +30,16 @@
 endif()
 
 add_library(fast_float INTERFACE)
+
+
+option(FASTFLOAT_BENCHMARKS "Enable benchmarks" OFF)
+if(FASTFLOAT_BENCHMARKS)
+  add_subdirectory(benchmarks)
+else(FASTFLOAT_BENCHMARKS)
+  message(STATUS "Benchmarks are disabled. Set FASTFLOAT_BENCHMARKS to ON to build benchmarks (assumes C++17).")
+endif(FASTFLOAT_BENCHMARKS)
+
+
 add_library(FastFloat::fast_float ALIAS fast_float)
 target_include_directories(
   fast_float

=== debian/changelog ===
fast-float (8.0.0-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream release 8.0.0 (Closes: #1095037)
  * Add debian/gbp.conf
  * Import packaging to Debian Salsa
  * Add debian/upstream/metadata

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 11 Feb 2025 18:01:56 -0500

=== debian/rules ===
#!/usr/bin/make -f
# You must remove unused comment lines for the released package.
#export DH_VERBOSE = 1
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	      -DCMAKE_INSTALL_DATAROOTDIR=lib

override_dh_auto_install:
	dh_auto_install --destdir=debian/libfast-float-dev/
	python3 script/amalgamate.py > fast_float_all.h

## fast-float 8.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
-cmake_minimum_required(VERSION 3.9)
+cmake_minimum_required(VERSION 3.14)
 
-project(fast_float VERSION 8.0.0 LANGUAGES CXX)
+
+project(fast_float VERSION 8.1.0 LANGUAGES CXX)
 set(FASTFLOAT_CXX_STANDARD 11 CACHE STRING "the C++ standard to use for fastfloat")
 set(CMAKE_CXX_STANDARD ${FASTFLOAT_CXX_STANDARD})
 option(FASTFLOAT_TEST "Enable tests" OFF)
@@ -55,10 +56,14 @@
     target_link_libraries(fast_float INTERFACE -fuse-ld=gold)
   endif()
 endif()
-if(MSVC_VERSION GREATER 1910)
+
+include(CheckCXXCompilerFlag)
+unset(FASTFLOAT_COMPILER_SUPPORTS_PERMISSIVE)
+CHECK_CXX_COMPILER_FLAG(/permissive- FASTFLOAT_COMPILER_SUPPORTS_PERMISSIVE)
+
+if(FASTFLOAT_COMPILER_SUPPORTS_PERMISSIVE)
   target_compile_options(fast_float INTERFACE /permissive-)
 endif()
-
 
 if(FASTFLOAT_INSTALL)
   include(CMakePackageConfigHelpers)

=== benchmarks/CMakeLists.txt ===
add_executable(realbenchmark benchmark.cpp)
set_property(
    TARGET realbenchmark
    PROPERTY CXX_STANDARD 17)

target_link_libraries(realbenchmark PUBLIC fast_float)
include(ExternalProject)

# Define the external project
ExternalProject_Add(simple_fastfloat_benchmark
    GIT_REPOSITORY https://github.com/lemire/simple_fastfloat_benchmark.git
    GIT_TAG        master  # or specify a particular commit/tag/branch
    SOURCE_DIR     ${CMAKE_BINARY_DIR}/simple_fastfloat_benchmark
    BINARY_DIR     ${CMAKE_BINARY_DIR}/simple_fastfloat_benchmark-build
    CONFIGURE_COMMAND ""
    BUILD_COMMAND ""
    INSTALL_COMMAND ""
)
set(DATA_DIR ${CMAKE_BINARY_DIR}/simple_fastfloat_benchmark/data)

add_custom_target(CopyData ALL
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${DATA_DIR} ${CMAKE_CURRENT_BINARY_DIR}/data
    DEPENDS simple_fastfloat_benchmark
)
add_dependencies(realbenchmark CopyData)
target_compile_definitions(realbenchmark PUBLIC BENCHMARK_DATA_DIR="${CMAKE_CURRENT_BINARY_DIR}/data")

=== tests/CMakeLists.txt ===
# FetchContent requires cmake >=3.11
# see https://cmake.org/cmake/help/v3.11/module/FetchContent.html
cmake_minimum_required(VERSION 3.11 FATAL_ERROR)

include(FetchContent)

option(SYSTEM_DOCTEST "Use system copy of doctest" OFF)
option(FASTFLOAT_SUPPLEMENTAL_TESTS "Run supplemental tests" ON)

if (NOT SYSTEM_DOCTEST)
  FetchContent_Declare(doctest
    GIT_REPOSITORY https://github.com/lemire/doctest.git)
else ()
  find_package(doctest REQUIRED)
endif()
if (FASTFLOAT_SUPPLEMENTAL_TESTS)
  FetchContent_Declare(supplemental_test_files
    GIT_REPOSITORY https://github.com/fastfloat/supplemental_test_files.git
    GIT_TAG origin/main)
endif()


# FetchContent_MakeAvailable() was only introduced in 3.14
# https://cmake.org/cmake/help/v3.14/release/3.14.html#modules
if (NOT SYSTEM_DOCTEST)
  FetchContent_MakeAvailable(doctest)
endif()

add_library(supplemental-data INTERFACE)
if (FASTFLOAT_SUPPLEMENTAL_TESTS)
  message(STATUS "Supplemental tests enabled. Retrieving test files.")
  FetchContent_MakeAvailable(supplemental_test_files)
  message(STATUS "Supplemental test files retrieved.")
  target_compile_definitions(supplemental-data INTERFACE SUPPLEMENTAL_TEST_DATA_DIR="${supplemental_test_files_BINARY_DIR}/data")
endif()

function(fast_float_add_cpp_test TEST_NAME)
    add_executable(${TEST_NAME} ${TEST_NAME}.cpp)
    if(CMAKE_CROSSCOMPILING)
        set(ccemulator ${CMAKE_CROSSCOMPILING_EMULATOR})
    endif()
    add_test(NAME ${TEST_NAME}
        COMMAND ${ccemulator} $<TARGET_FILE:${TEST_NAME}>)
    if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
      target_compile_options(${TEST_NAME} PUBLIC /EHsc)
    endif()
    if(NOT WIN32)
      target_compile_options(${TEST_NAME} PUBLIC -Werror -Wall -Wextra -Weffc++)
      target_compile_options(${TEST_NAME} PUBLIC -Wsign-compare -Wshadow -Wwrite-strings -Wpointer-arith -Winit-self -Wconversion -Wsign-conversion)
    endif()
    target_link_libraries(${TEST_NAME} PUBLIC fast_float supplemental-data)
    if (NOT SYSTEM_DOCTEST)
      target_link_libraries(${TEST_NAME} PUBLIC doctest)
    else ()
      target_link_libraries(${TEST_NAME} PUBLIC doctest::doctest)
    endif()
endfunction(fast_float_add_cpp_test)

fast_float_add_cpp_test(rcppfastfloat_test)
fast_float_add_cpp_test(wide_char_test)
fast_float_add_cpp_test(supported_chars_test)
fast_float_add_cpp_test(example_test)
fast_float_add_cpp_test(example_comma_test)
fast_float_add_cpp_test(example_integer_times_pow10)
fast_float_add_cpp_test(basictest)
option(FASTFLOAT_CONSTEXPR_TESTS "Require constexpr tests (build will fail if the compiler won't support it)" OFF)
if (FASTFLOAT_CONSTEXPR_TESTS)
  target_compile_features(basictest PRIVATE cxx_std_20)
  target_compile_definitions(basictest PRIVATE FASTFLOAT_CONSTEXPR_TESTS)
else()
  target_compile_features(basictest PRIVATE cxx_std_17)
endif()
if (FASTFLOAT_SUPPLEMENTAL_TESTS)
  target_compile_definitions(basictest PRIVATE FASTFLOAT_SUPPLEMENTAL_TESTS)
endif()
fast_float_add_cpp_test(p2497)
fast_float_add_cpp_test(long_test)
fast_float_add_cpp_test(powersoffive_hardround)
fast_float_add_cpp_test(string_test)
fast_float_add_cpp_test(fast_int)
target_compile_features(fast_int PRIVATE cxx_std_17)
fast_float_add_cpp_test(json_fmt)
fast_float_add_cpp_test(fortran)
if(CMAKE_CXX_STANDARD GREATER_EQUAL 23)
  option(FASTFLOAT_FIXEDWIDTH_TESTS "Require fixed width test for C++23 (build will fail if the compiler won't support it)" ON)
else()
  option(FASTFLOAT_FIXEDWIDTH_TESTS "Require fixed width test for C++23 (build will fail if the compiler won't support it)" OFF)
endif()
if (FASTFLOAT_FIXEDWIDTH_TESTS)
  fast_float_add_cpp_test(fixedwidthtest)
  target_compile_features(fixedwidthtest PUBLIC cxx_std_23)
endif()

option(FASTFLOAT_EXHAUSTIVE "Exhaustive tests" OFF)

if (FASTFLOAT_EXHAUSTIVE)
  fast_float_add_cpp_test(short_random_string)
  fast_float_add_cpp_test(exhaustive32_midpoint)
  fast_float_add_cpp_test(random_string)
  fast_float_add_cpp_test(exhaustive32)
  fast_float_add_cpp_test(exhaustive32_64)
  fast_float_add_cpp_test(long_exhaustive32)
  fast_float_add_cpp_test(long_exhaustive32_64)
  fast_float_add_cpp_test(long_random64)
  fast_float_add_cpp_test(random64)
endif(FASTFLOAT_EXHAUSTIVE)

add_subdirectory(build_tests)
add_subdirectory(bloat_analysis)

=== tests/installation_tests/find/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

project(test_install VERSION 0.1.0 LANGUAGES CXX)

set(FASTFLOAT_CXX_STANDARD 17 CACHE STRING "the C++ standard to use for fastfloat")
set(CMAKE_CXX_STANDARD ${FASTFLOAT_CXX_STANDARD})
set(CMAKE_CXX_STANDARD_REQUIRED ON)
if(MSVC_VERSION GREATER 1910)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -permissive-")
endif()
find_package(FastFloat REQUIRED)



file(WRITE main.cpp "
#include \"fast_float/fast_float.h\"
#include <iostream>

int main() {
    std::string input = \"3.1416 xyz \";
    double result;
    auto answer = fast_float::from_chars(input.data(), input.data()+input.size(), result);
    if (answer.ec != std::errc()) { std::cerr << \"parsing failure\\n\"; return EXIT_FAILURE; }
    std::cout << \"parsed the number \" << result << std::endl;
    return EXIT_SUCCESS;
}")



add_executable(repro main.cpp)
target_link_libraries(repro PUBLIC FastFloat::fast_float)

=== debian/changelog ===
fast-float (8.1.0-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release: v8.1.0. (Closes: #1115913)
  * Fix FTBFS after prior build and remove superfluous d/install file; thanks to
    Lucas Nussbaum for providing a patch. (Closes: #1045133)
  * d/control:
    - Add dh-sequence-single-binary, dpkg-build-api (= 1) and doctest-dev to
      Build-Depends, and (>= 3.14) version constraint to cmake dependency.
    - Bump Standards-Version to 4.7.2; no changes required.
    - Convert libfast-float-dev package to Architecture: all. (Closes: #1098316)
  * d/copyright: Refresh authors and update to current triple exclusive-or
    license grants with new Boost Software License v1.0 option.
  * d/rules: Enable upstream test suite and switch to CMake Ninja generator.
  * Add debian/salsa-ci.yml for Salsa CI/CD pipelines.

 -- Peter J. Mello <admin@petermello.net>  Thu, 09 Oct 2025 11:46:41 -0700

=== debian/control ===
Source: fast-float
Section: libdevel
Priority: optional
Maintainer: Fukui Daichi <a.dog.will.talk@akane.waseda.jp>
Build-Depends: debhelper-compat (= 13), dh-sequence-single-binary,
 dpkg-build-api (= 1), cmake (>= 3.14), ninja-build, python3,
 doctest-dev <!nocheck>
Standards-Version: 4.7.2
Homepage: https://github.com/fastfloat/fast_float
Vcs-Git: https://salsa.debian.org/debian/fast-float.git
Vcs-Browser: https://salsa.debian.org/debian/fast-float
Rules-Requires-Root: no

Package: libfast-float-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: C++ from_chars function implementations for float and double types
 The FastFloat library provides fast, header-only implementations for the C++
 from_chars functions for converting ASCII strings representing decimal values
 into binary float and double types with exact rounding (including the less-
 biased "to even" approach). These fast_float functions run many times faster
 than comparable number parsing functions from the current C++ standard
 libraries from GCC and LLVM.
 .
 FastFloat provides performance comparable to that of the fast_double_parser
 library, but uses an updated algorithm that has been reworked from the ground
 up and offers an API more in keeping with the expectations of C++ programmers.
 .
 This package contains the library header files for inclusion by other projects
 and an amalgamated single-file header, fast_float_all.h, for added convenience.

=== debian/rules ===
#!/usr/bin/make -f
# SPDX-FileCopyrightText: © 2022, Fukui Daichi <a.dog.will.talk@akane.waseda.jp>
# SPDX-FileCopyrightText: © 2025, Peter J. Mello <admin@petermello.net>
#
# SPDX-License-Identifier: Apache-2.0 OR MIT

export DH_VERBOSE             ::= 1
export DPKG_EXPORT_BUILDFLAGS ::= 1

include /usr/share/dpkg/default.mk

PKG_INSTALL_DIR   ::= $(CURDIR)/debian/libfast-float-dev


%:
	dh $@ -v -Scmake+ninja


override_dh_auto_configure:
	dh_auto_configure -O-v -O-Scmake+ninja -- -DFASTFLOAT_BENCHMARKS:BOOL=OFF \
		-DFASTFLOAT_CONFIG_INSTALL_DIR:PATH=/usr/share/cmake/FastFloat \
		-DFASTFLOAT_CONSTEXPR_TESTS:BOOL=OFF -DFASTFLOAT_EXHAUSTIVE:BOOL=OFF \
		-DFASTFLOAT_FIXEDWIDTH_TESTS:BOOL=OFF \
		-DFASTFLOAT_SUPPLEMENTAL_TESTS:BOOL=OFF \
		-DFASTFLOAT_TEST:BOOL=ON -DSYSTEM_DOCTEST:BOOL=ON

execute_after_dh_auto_install:
	@mkdir -pv "$(PKG_INSTALL_DIR)/usr/include/fast_float"
	@python3 "$(CURDIR)/script/amalgamate.py" --license TRIPLE \
		--output "$(PKG_INSTALL_DIR)/usr/include/fast_float/fast_float_all.h" \
			&& echo "Amalgamated header file generated successfully!"

=== debian/watch ===
# SPDX-FileCopyrightText: © 2022, Fukui Daichi <a.dog.will.talk@akane.waseda.jp>
# SPDX-FileCopyrightText: © 2025, Peter J. Mello <admin@petermello.net>
# SPDX-License-Identifier: Apache-2.0 OR MIT
version=4
opts="pgpmode=none,searchmode=plain" \
 https://api.github.com/repos/fastfloat/fast_float/git/matching-refs/tags/ \
  https://api.github.com/repos/fastfloat/fast_float/git/refs/tags/@ANY_VERSION@
